// BmpFile.cpp: implementation of the CBmpFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BmpFileView.h"
#include "BmpFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBmpFile::CBmpFile() :
	m_PaletteSize(0),
	m_BitsSize(0),
	m_LineSize(0),
	m_pInfo(NULL),
	m_pBits(NULL),
	b_LoadBits(FALSE) //Ĭϲλͼ
{
}

CBmpFile::~CBmpFile()
{
	this->Clear();
}

//һλͼϢ
BOOL CBmpFile::LoadFile(LPCTSTR lpszFileName)
{
	CFile file;
	if(file.Open(lpszFileName, CFile::modeRead))
	{
		//ͷѾڴ
		this->Clear();

		this->m_pInfo = (BITMAPINFO*)::malloc(sizeof(BITMAPINFO));

		//ȡļͷ
		file.Read(&this->m_fileHeader, sizeof(this->m_fileHeader));
		//ȡϢͷ
		file.Read(this->m_pInfo, sizeof(BITMAPINFOHEADER));

		//ɨп
		this->m_LineSize = this->CalcLineSize(
			this->m_pInfo->bmiHeader.biBitCount,
			this->m_pInfo->bmiHeader.biWidth
			);

		//ɫԪ
		this->m_PaletteSize = this->CalcPaletteSize(
			this->m_pInfo->bmiHeader.biBitCount,
			this->m_pInfo->bmiHeader.biClrUsed,
			this->m_pInfo->bmiHeader.biCompression
			);

		//صɫ
		if(this->m_PaletteSize > 0)
		{
			this->m_pInfo == (BITMAPINFO*)::realloc(this->m_pInfo,
				sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*this->m_PaletteSize
				);
			file.Read(&this->m_pInfo->bmiColors, sizeof(RGBQUAD)*this->m_PaletteSize);
		}

		//λͼ
		this->m_BitsSize = this->m_fileHeader.bfSize - this->m_fileHeader.bfOffBits;
		if(this->b_LoadBits)
		{
			this->m_pBits = ::malloc(this->m_BitsSize);
			file.Read(this->m_pBits, this->m_BitsSize);
		}
		file.Close();
		return TRUE;
	}
	return FALSE;
}

//ͷԴ
void CBmpFile::Clear()
{
	if(this->m_pInfo != NULL)
	{
		::free(this->m_pInfo);
		this->m_pInfo = NULL;
	}

	if(this->m_pBits != NULL)
	{
		::free(this->m_pBits);
		this->m_pBits = NULL;
	}
}
