// PeFile.cpp: implementation of the CPeFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BmpFileView.h"
#include "PeFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPeFile::CPeFile() :
	m_pSectionHeaders(NULL)
{

}

CPeFile::~CPeFile()
{
	//ͷѾڴ
	this->Clear();
}


//PEļ
BOOL CPeFile::LoadFile(LPCTSTR lpszFileName)
{
	CFile file;
	if(file.Open(lpszFileName, CFile::modeRead))
	{
		size_t nSize;
		//ͷѾڴ
		this->Clear();
		//
		// [1] IMAGE_DOS_HEADER
		//
		file.Read(&m_dosHeader, sizeof(m_dosHeader));
		
		// dos stub ռ˶ٸֽڣΪһڵӵؼ
		this->m_nDosStubSize = m_dosHeader.e_lfanew - sizeof(m_dosHeader);

		//ȻԽDOS StubֱNT Header
		file.Seek(m_dosHeader.e_lfanew, CFile::begin);

		//
		// [2] IMAGE_NT_HEADERS
		//
		file.Read(&m_ntHeaders, sizeof(m_ntHeaders));

		//
		// [3] IMAGE_SECTION_HEADER[]
		//
		//Ƿڴ
		nSize = sizeof(IMAGE_SECTION_HEADER) * m_ntHeaders.FileHeader.NumberOfSections;
		m_pSectionHeaders = (PIMAGE_SECTION_HEADER)::malloc(nSize);

		file.Read(m_pSectionHeaders, nSize);

		// չ
		file.Close();
		return TRUE;
	}
	return FALSE;
}

//ڴ
void CPeFile::Clear()
{
	if(m_pSectionHeaders != NULL)
	{
		::free(m_pSectionHeaders);
		m_pSectionHeaders = NULL;
	}
}

//ȡsection bodyĴСܺͣ
size_t CPeFile::GetSizeOfAllSections()
{
	size_t i, nSize = 0;
	if(this->m_pSectionHeaders == NULL)
		return nSize;

	for(i=0; i<this->m_ntHeaders.FileHeader.NumberOfSections; i++)
	{
		nSize += this->m_pSectionHeaders[i].SizeOfRawData;
	}
	return nSize;
}

//ȡsection Headers ֮sectionʼ֮ǰǶβֽڵĴС
//עΪsectionļǰFileAlignmentġ
//FileAlignment 512 ~ 64K ֮䣬һ2η
size_t CPeFile::GetDummySize()
{
	//Ȼȡsectionʼ֮ǰݵĴС
	size_t nSize = 0;
	nSize += sizeof(this->m_dosHeader);
	nSize += this->m_nDosStubSize;
	nSize += sizeof(this->m_ntHeaders);
	nSize += sizeof(IMAGE_SECTION_HEADER) * m_ntHeaders.FileHeader.NumberOfSections;

	//ǵõ֮ǰݵĴС( 0x200)
	DWORD dwAlign = m_ntHeaders.OptionalHeader.FileAlignment;

	//ǲһЩֽڣʹַƶdwAlignλ
	return (dwAlign - (nSize & (dwAlign - 1)));
}

//עsectionsļfileAlignment룬ڽsectionAlignment
//֮ƫͶйأŶεĲͬͬ
//ԱȷrvaλǸΣٴӸöεϢлȡļַ
DWORD CPeFile::RvaToFileAddress(DWORD rva)
{
	int i, iSection = -1;
	if(this->m_pSectionHeaders == NULL)
		return 0;

	//ҸRvaλǸ
	for(i=0; i<this->m_ntHeaders.FileHeader.NumberOfSections; i++)
	{
		if(rva >= this->m_pSectionHeaders[i].VirtualAddress
			&& (rva <= this->m_pSectionHeaders[i].VirtualAddress + this->m_pSectionHeaders[i].Misc.VirtualSize))
		{
			//rvaλڸö
			iSection = i;
			break;
		}
	}

	//δҵ
	if(iSection < 0) return 0;

	//
	return this->m_pSectionHeaders[iSection].PointerToRawData + 
		(rva - this->m_pSectionHeaders[iSection].VirtualAddress);
}
